<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">

<xsl:template match="/">
<html>
  <head>
    <title>XSLサンプル</title>
    <link rel="StyleSheet" href="sample.css" />
  </head>
  <body>
    <xsl:apply-templates />
  </body>
</html>
</xsl:template>

<xsl:template match="source">
  <xsl:for-each select="data">

  <div class="head">
    <span class="item">
      <xsl:value-of select="./@scope" />
    </span>

    <xsl:if test="./@option!=''">
      <span class="item">
        <xsl:value-of select="./@option" />
      </span>
    </xsl:if>

    <span class="item">
      <xsl:value-of select="./@type" />
    </span>

    <span class="item">
      <xsl:value-of select="./@name" />
    </span>
  </div>

  <div class="containts">
    <span class="topic topic_summary">
      summary
    </span>
    <span class="item">
      <xsl:value-of select="./summary" />
    </span>

    <xsl:for-each select="param">
      <span class="topic topic_param">
        param
      </span>
      <span class="item">
        <xsl:value-of select="./@name" />
      </span>
      <span class="item">
        <xsl:value-of select="." />
      </span>
    </xsl:for-each>

    <xsl:for-each select="returns">
      <span class="topic topic_returns">
        returns
      </span>
      <span class="item">
        <xsl:value-of select="." />
      </span>
    </xsl:for-each>

    <span class="topic topic_remarks">
      remarks
    </span>
    <span class="item">
      <xsl:value-of select="./remarks" />
    </span>
  </div>
  </xsl:for-each>
</xsl:template>

</xsl:stylesheet>
