﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace VBtoXML
{
    static class ConvartClass
    {
        /// <summary>
        /// VB.netソースからxmlの変換処理
        /// </summary>
        /// <param name="source">vb.netのソース</param>
        /// <param name="xmlHeader">xmlの冒頭に追加するヘッダ情報</param>
        /// <returns></returns>
        public static string convert(string source,string xmlHeader)
        {
            StringReader sr;
            string line;
            string mode = "Search";
            string headerText = string.Empty;
            //検索項目：対象の種別
            string[] types = { "Property", "Sub", "Function", "Class" };
            //検索項目：スコープ
            string[] scopes = { "Public", "Private", "Partial", "Protected" };
            //検索項目：プロパティオプション
            string[] properryOptions = { "WriteOnly", "ReadOnly" };

            //戻り値
            string result = xmlHeader + Environment.NewLine;

            result += "<root><source>" + Environment.NewLine;

            sr = new StringReader(source);
            while ((line = sr.ReadLine()) != null)
            {
                switch (mode)
                {
                    case "Search":
                        if (line.IndexOf("'''") >= 0)
                        {
                            headerText = line.Replace("'''", string.Empty);
                            mode = "SetHeader";
                        }
                        break;
                    case "SetHeader":
                        if (line.IndexOf("'''") >= 0)
                        {
                            headerText += line.Replace("'''", string.Empty);
                        }
                        else
                        {
                            //CheckType
                            string name = string.Empty;
                            int index = 0;

                            foreach (string type in types)
                            {
                                if ((index = line.IndexOf(type)) >= 0)
                                {
                                    name = line.Substring(index + type.Length + 1);
                                    name = name.Substring(0, name.IndexOf("("));
                                    result += "<data " + " type='" + type + "'" + " name='" + name + "'";

                                    foreach (string scope in scopes)
                                    {
                                        if (line.IndexOf(scope) >= 0)
                                        {
                                            result += " scope='" + scope + "'";
                                        }
                                    }


                                    foreach (string option in properryOptions)
                                    {
                                        if (line.IndexOf(option) >= 0)
                                        {
                                            result += " option='" + option + "'";
                                        }
                                    }

                                    result += ">" + Environment.NewLine;
                                    result += headerText + Environment.NewLine;
                                    result += "</data>" + Environment.NewLine;

                                    break;
                                }
                            }

                            headerText = string.Empty;
                            mode = "Search";
                        }
                        break;
                }

            }
            result += "</source></root>";

            return result;
        }
    }
}
