﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace VBtoXML
{
    public partial class FormDirConv : Form
    {
        public FormDirConv()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            this.textBox1.Text = string.Empty;
            this.folderBrowserDialog1.SelectedPath = Application.StartupPath;
            this.folderBrowserDialog1.ShowDialog();
            this.textBox1.Text = this.folderBrowserDialog1.SelectedPath;
        }

        private void button2_Click(object sender, EventArgs e)
        {
            this.textBox2.Text = string.Empty;
            this.folderBrowserDialog2.SelectedPath = Application.StartupPath;
            this.folderBrowserDialog2.ShowDialog();
            this.textBox2.Text = this.folderBrowserDialog2.SelectedPath;
        }

        private void button3_Click(object sender, EventArgs e)
        {
            string validateMessage = string.Empty;
            if (string.Empty.Equals(this.textBox1.Text))
            {
                validateMessage += "ソースのフォルダを指定してください。" + Environment.NewLine;
            }
            if (string.Empty.Equals(this.textBox2.Text))
            {
                validateMessage += "XMLのフォルダを指定してください。" + Environment.NewLine;
            }

            if (!string.Empty.Equals(validateMessage))
            {
                MessageBox.Show(validateMessage);
                return;
            }

            this.convartFiles();
        }
 
        void convartFiles()
        {

            string[] files = Directory.GetFiles(
               this.textBox1.Text, "*.vb", SearchOption.AllDirectories);

            string xmlFilePanth;
            string xmlData;

            foreach (string filePath in files)
            {

                //LoadSource
                StreamReader inFile = new StreamReader(filePath);
                xmlData = ConvartClass.convert(inFile.ReadToEnd(), this.txtOptionHeader.Text);
                inFile.Close();

                //CreateSource
                xmlFilePanth = this.textBox2.Text + Path.DirectorySeparatorChar + Path.GetFileName(filePath).Replace("vb", "xml");
                StreamWriter outFile = new StreamWriter(xmlFilePanth);
                outFile.Write(xmlData);
                outFile.Close();

            }
        }
    }
}
